*
* READER.PRG
*
* Visual FoxPro "READER" program (for SEE 3.0 and above)
*
* This program logs onto POP3 server 'Pop3Server' and downloads
* message number 'MsgNbr' into directory 'EmailDir' as a file named
* 'EmailName'. Any attachment is downloaded into directory 'AttachDir'.
*
*

#INCLUDE KEYCODE.FOX
#INCLUDE SEE32CON.FOX

DECLARE INTEGER seeAttach in SEE32.DLL INTEGER NbrChans, INTEGER KeyCode
DECLARE INTEGER seeClose in SEE32.DLL INTEGER Chan
DECLARE INTEGER seeCommand in SEE32.DLL INTEGER Chan, STRING @Text
DECLARE INTEGER seeDebug in SEE32.DLL INTEGER Chan, INTEGER Index, STRING @Buffer, INTEGER BufLen
DECLARE INTEGER seeDecodeBuffer in SEE32.DLL STRING @CodedBuf, STRING @ClearBuf, INTEGER BufLen
DECLARE INTEGER seeDeleteEmail in SEE32.DLL INTEGER Chan, INTEGER MsgNbr
DECLARE INTEGER seeDriver in SEE32.DLL INTEGER Chan
DECLARE INTEGER seeEncodeBuffer in SEE32.DLL STRING @ClearBuf, STRING @CodedBuf, INTEGER BufLen
DECLARE INTEGER seeErrorText in SEE32.DLL INTEGER Chan, INTEGER Code, STRING @Buffer, INTEGER BufLen
DECLARE INTEGER seeExtractLine in SEE32.DLL STRING @Source, INTEGER LineNbr, STRING @Buffer, INTEGER BufLen
DECLARE INTEGER seeExtractText in SEE32.DLL STRING @Source, STRING @Text, STRING @Buffer, INTEGER BufLen
DECLARE INTEGER seeGetEmailCount in SEE32.DLL INTEGER Chan
DECLARE INTEGER seeGetEmailFile in SEE32.DLL INTEGER Chan, INTEGER MsgNbr, STRING @EmailName, STRING @EmailDir, STRING @AttachDir
DECLARE INTEGER seeGetEmailLines in SEE32.DLL INTEGER Chan, INTEGER MsgNbr, INTEGER Lines, STRING @Buffer, INTEGER BufLen
DECLARE INTEGER seeGetEmailSize in SEE32.DLL INTEGER Chan, INTEGER MsgNbr
DECLARE INTEGER seeGetEmailUID in SEE32.DLL INTEGER Chan, INTEGER MsgNbr, STRING @Buffer, INTEGER BufLen
DECLARE INTEGER seeIntegerParam in SEE32.DLL INTEGER Chan, INTEGER Param, INTEGER Value
DECLARE INTEGER seePop3Connect in SEE32.DLL INTEGER Chan, STRING @Server, STRING @User, STRING @Password
DECLARE INTEGER seeRelease in SEE32.DLL
DECLARE INTEGER seeSendEmail in SEE32.DLL INTEGER Chan, STRING @To, STRING @CC, STRING @BCC, STRING @Subj, STRING @Msg, STRING @Attach
DECLARE INTEGER seeSmtpConnect in SEE32.DLL INTEGER Chan, STRING @Server, STRING @From, STRING @Reply
DECLARE INTEGER seeStatistics in SEE32.DLL INTEGER Chan, INTEGER Index
DECLARE INTEGER seeStringParam in SEE32.DLL INTEGER Chan, INTEGER Param, STRING @Value
DECLARE INTEGER seeVerifyFormat in SEE32.DLL STRING @User
DECLARE INTEGER seeVerifyUser in SEE32.DLL INTEGER Chan, STRING @User

*** PROGRAMMER: Edit these strings [use host name or IP address for server] ***
Pop3Server = "10.0.0.1"
Pop3UserName = "mike"
Pop3Password  = "mike"
DiagFile = "C:\TEMP\reader.log"
* Note 1: do NOT use pathname in EmailName
EmailName = "email.txt"
* Note 2: use full path names unless file is located in FoxPro directory
EmailDir = "C:\TEMP"
AttachDir = "C:\TEMP"
*** END PROGRAMMER ***

? "READER 02/10/2000"
Code = seeAttach(1, SEE_KEY_CODE)
if Code < 0
  ? "Cannot attach SEE"
  return
endif
Code = seeStringParam(0,SEE_LOG_FILE, @DiagFile)
* set maximum connect wait to 10 seconds
Code = seeIntegerParam(0, SEE_CONNECT_WAIT, 10000)
* connect to POP3 server
? "Connecting to " + Pop3Server
Code = seePop3Connect(0, @Pop3Server, @Pop3UserName, @Pop3Password)
if Code < 0
  Temp = SPACE(128)
  Code = seeErrorText(0, Code, @Temp, 128)
  ? Left(Temp,Code)
else
  * get # messages waiting
  ? "Getting message status..."
  NbrMessages = seeGetEmailCount(0)
  if NbrMessages < 0
    Temp = SPACE(128)
    Code = seeErrorText(0, NbrMessages, @Temp, 128)
    ? Left(Temp,Code)
  else
    ? NbrMessages," messages waiting."
    If NbrMessages = 0
      Code = seeClose(0)
      Code = seeRelease()
      return
    Endif
    ? "Enter message # to read (and delete):"
    MsgNbr = AcceptInteger()
    If (MsgNbr>0) And (MsgNbr <= NbrMessages)
      ? "Reading Message ", LTRIM(STR(MsgNbr)), ", please wait..."
      Code = seeGetEmailFile(0, MsgNbr, @EmailName, @EmailDir, @AttachDir)
      if Code < 0
        Temp = SPACE(128)
        Code = seeErrorText(0, Code, @Temp, 128)
        ? Left(Temp,Code)
        Code = seeClose(0)
        Code = seeRelease()
        return
      endif
      ? "Saved as ", LTRIM(EmailName)
      * deleting message from server
      Code = seeDeleteEmail(0, MsgNbr)
      ? "Message ",  LTRIM(STR(MsgNbr)), " deleted from server."
    else
      ? "No such message"
    endif
  endif
endif
? "Done."
Code = seeClose(0)
Code = seeRelease()
return

Function AcceptInteger()
Private Value
Private X
Value = 0
DO While Value >= 0
  X = InKey(0)
  ?? Chr(X)
  If (X >= Asc("0")) And (X <= Asc("9"))
    Value = 10 * Value + (X - Asc("0"))
  else
    exit
  endif
Enddo
return Value
