*
* STATUS2.PRG
*
* Visual FoxPro "STATUS" program (for SEE 3.2) that uses seeDriver.
* This program lists all email waiting on the specified POP3 server.
*
* Note that the 4th argument to seeGetEmailLines is 0 rather than
* a buffer, which will force SEE to use its internal memory. This
* is necessary since otherwise FoxPro may move its memory at runtime.
* After seeDriver completes running, the SEE internal buffer can be
* copied using seeDebug(Chan, SEE_COPY_BUFFER, ...).
*
* This precaution is ONLY necessary when using the SEE driver seeDriver.
* Compare this program to STATUS.PRG.
*

#INCLUDE KEYCODE.FOX
#INCLUDE SEE32CON.FOX

DECLARE INTEGER seeAttach in SEE32.DLL INTEGER NbrChans, INTEGER KeyCode
DECLARE INTEGER seeClose in SEE32.DLL INTEGER Chan
DECLARE INTEGER seeCommand in SEE32.DLL INTEGER Chan, STRING @Text
DECLARE INTEGER seeDebug in SEE32.DLL INTEGER Chan, INTEGER Index, STRING @Buffer, INTEGER BufLen
DECLARE INTEGER seeDecodeBuffer in SEE32.DLL STRING @CodedBuf, STRING @ClearBuf, INTEGER BufLen
DECLARE INTEGER seeDeleteEmail in SEE32.DLL INTEGER Chan, INTEGER MsgNbr
DECLARE INTEGER seeDriver in SEE32.DLL INTEGER Chan
DECLARE INTEGER seeEncodeBuffer in SEE32.DLL STRING @ClearBuf, STRING @CodedBuf, INTEGER BufLen
DECLARE INTEGER seeErrorText in SEE32.DLL INTEGER Chan, INTEGER Code, STRING @Buffer, INTEGER BufLen
DECLARE INTEGER seeExtractLine in SEE32.DLL STRING @Source, INTEGER LineNbr, STRING @Buffer, INTEGER BufLen
DECLARE INTEGER seeExtractText in SEE32.DLL STRING @Source, STRING @Text, STRING @Buffer, INTEGER BufLen
DECLARE INTEGER seeGetEmailCount in SEE32.DLL INTEGER Chan
DECLARE INTEGER seeGetEmailFile in SEE32.DLL INTEGER Chan, INTEGER MsgNbr, STRING @EmailName, STRING @EmailDir, STRING @AttachDir
DECLARE INTEGER seeGetEmailLines in SEE32.DLL INTEGER Chan, INTEGER MsgNbr, INTEGER Lines, STRING @Buffer, INTEGER BufLen
DECLARE INTEGER seeGetEmailSize in SEE32.DLL INTEGER Chan, INTEGER MsgNbr
DECLARE INTEGER seeGetEmailUID in SEE32.DLL INTEGER Chan, INTEGER MsgNbr, STRING @Buffer, INTEGER BufLen
DECLARE INTEGER seeIntegerParam in SEE32.DLL INTEGER Chan, INTEGER Param, INTEGER Value
DECLARE INTEGER seePop3Connect in SEE32.DLL INTEGER Chan, STRING @Server, STRING @User, STRING @Password
DECLARE INTEGER seeRelease in SEE32.DLL
DECLARE INTEGER seeSendEmail in SEE32.DLL INTEGER Chan, STRING @To, STRING @CC, STRING @BCC, STRING @Subj, STRING @Msg, STRING @Attach
DECLARE INTEGER seeSmtpConnect in SEE32.DLL INTEGER Chan, STRING @Server, STRING @From, STRING @Reply
DECLARE INTEGER seeStatistics in SEE32.DLL INTEGER Chan, INTEGER Index
DECLARE INTEGER seeStringParam in SEE32.DLL INTEGER Chan, INTEGER Param, STRING @Value
DECLARE INTEGER seeVerifyFormat in SEE32.DLL STRING @User
DECLARE INTEGER seeVerifyUser in SEE32.DLL INTEGER Chan, STRING @User

*** PROGRAMMER: Edit these strings [use host name or IP address for server] ***
Pop3Server = "10.0.0.1"
Pop3UserName = "mike"
Pop3Password  = "mike"
DiagFile = "C:\TEMP\status2.log"
*** END PROGRAMMER ***

? "DRIVER 12/10/99"
if seeAttach(1, SEE_KEY_CODE) < 0
  ? "Cannot attach SEE"
  return
endif
Code = seeStringParam(0,SEE_LOG_FILE, @DiagFile)
* connect to POP3 server
? "Connecting to " + Pop3Server
* set maximum connect wait to 10 seconds
Code = seeIntegerParam(0, SEE_CONNECT_WAIT, 10000)
Code = seePop3Connect(0,@Pop3Server, @Pop3UserName, @Pop3Password)
if Code < 0
  Temp = SPACE(128)
  Code = seeErrorText(0,Code,@Temp,128)
  ? Left(Temp,Code)
else
  * get # messages waiting
  ? "Getting message status..."
  NbrMsg = seeGetEmailCount(0)
  if NbrMsg < 0
    Temp = SPACE(128)
    Code = seeErrorText(0,NbrMsg,@Temp,128)
    ? Left(Temp,Code)
  else
    ? NbrMsg," messages waiting."
    For I = 1 to NbrMsg
      ? "----- Message ", LTRIM(STR(I)) + " -----"
      * disable AUTO CALL
      Code = seeIntegerParam(0, SEE_AUTO_CALL_DRIVER, 0)

      *********************************************************
      * use internal SEE memory (pass 0 as 4th argument)      *
      * since FoxPro may move memory it allocates at runtime. *
      *********************************************************
      Code = seeGetEmailLines(0, I, 0, 0, 3000)

      Do while .T.
        Code = seeDriver(0)
        if Code = 0
          Exit
        endif
        if Code < 0
          Temp = SPACE(128)
          Code = seeErrorText(0,Code,@Temp,128)
          ? Left(Temp,Code)
          Code = seeClose(0)
          Code = seeRelease()
          return
        endif
        nBytes = seeStatistics(0, SEE_GET_TOTAL_BYTES_READ)
        ? nBytes, " bytes read"
      Enddo
      * re-enable AUTO CALL
      Code = seeIntegerParam(0, SEE_AUTO_CALL_DRIVER, 1)
      * copy internal SEE memory buffer
      Buffer = SPACE(3000)
      Code = seeDebug(0, SEE_COPY_BUFFER, @Buffer, 3000)
      * display "DATE: " line
      Temp = SPACE(128)
      Code = seeExtractText(@Buffer, "Date: ", @Temp, 128)
      if Code > 0
        ? Left(Temp,Code)
      endif
      * display "FROM: " line
      Temp = SPACE(128)
      Code = seeExtractText(@Buffer, "From: ", @Temp, 128)
      if Code > 0
        ?? Left(Temp,Code)
      endif
      * display "SUBJECT: " line
      Temp = SPACE(128)
      Code = seeExtractText(@Buffer, "Subject: ", @Temp, 128)
      if Code > 0
        ?? Left(Temp,Code)
      endif
    Endfor
   ? "----- END -----"
  endif
endif
? "Done."
Code = seeClose(0)
Code = seeRelease()
return

